unit unLincoTrd;
{
    LiveInCode - a graphical front-end to LineInCode
    Copyright (C) 2003-2004 Roman Mamedov
    <E-Mail: roman@rm.pp.ru, Website: http://rm.pp.ru/?1.liveincode>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

interface

uses
  Windows, Classes;

type
  TLincoTrd = class(TThread)
  public
    CommandLine:String;
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

implementation

uses unLiveInCode;

{ TLincoTrd }

function RunSync(const CommandLine: string):Boolean;
var
  si: STARTUPINFO;
  pi: PROCESS_INFORMATION;
  ExitCode:Cardinal;
begin
  ZeroMemory(@si, sizeof(si));
  si.cb := SizeOf(si);
  si.dwFlags := STARTF_USESHOWWINDOW;
  si.wShowWindow := SW_HIDE;//SW_SHOWNORMAL;
  if not CreateProcess(nil, // No module name (use command line).
    PChar(CommandLine), // Command line.
    nil, // Process handle not inheritable.
    nil, // Thread handle not inheritable.
    False, // Set handle inheritance to FALSE.
    0, // No creation flags.
    nil, // Use parent's environment block.
    nil, // Use parent's starting directory.
    si, // Pointer to STARTUPINFO structure.
    pi){// Pointer to PROCESS_INFORMATION structure.} then
  begin
    Result := False;
    Exit;
  end;
  WaitForSingleObject(pi.hProcess, INFINITE);
  GetExitCodeProcess(pi.hProcess, ExitCode);
  Result := (ExitCode <> 0);
  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);
end;

procedure TLincoTrd.Execute;
begin
  nowRecording := True;
  fmMain.FileLabelAsLink(True);
  fmMain.btRecord.Enabled := False;
  fmMain.btStop.Enabled := True;
  fmMain.btPause.Enabled := True;
  fmMain.pStatus.Caption := 'Recording...';
  fmMain.tmr.Enabled := True;
  RunSync(Self.CommandLine);
  SetLincoStopFlag(False);
  SetLincoPauseFlag(False);
  fmMain.tmr.Enabled := False;
  fmMain.btRecord.Enabled := True;
  fmMain.btStop.Enabled := False;
  fmMain.btPause.Enabled := False;
  fmMain.pStatus.Caption := 'Stopped';
//  fmLincoGUI.FileLabelAsLink(True);
  nowRecording := False; 
end;

end.
